﻿using System.Text;
using HeuristicLab.Common;
using HeuristicLab.Core;

namespace HeuristicLab.Clients.Hive.CloudManager.Model {
  public class Subscription : Item, IContent {
    public string SubscriptionID { get; set; }
    public string SubscriptionName { get; set; }
    public int MaxCoreCount { get; set; }
    public int MaxHostedServices { get; set; }
    public int CurrentCoreCount { get; set; }
    public int CurrentHostedServices { get; set; }
    public string CertificateThumbprint { get; set; }
    public bool SaveToConfig { get; set; }
    public bool DiscoverServices { get; set; }

    public Subscription() {

    }

    public Subscription(Subscription original, Cloner cloner) {

    }

    //public Subscription(Subscription original, Cloner cloner) {}

    public override string ToString() {
      StringBuilder sb = new StringBuilder();
      sb.AppendFormat("AzureSubscription: Id={0}, Name={1}, CoreCount={2}/{3}, HostedServices={4}/{5};", SubscriptionID, SubscriptionName, CurrentCoreCount, MaxCoreCount, CurrentHostedServices, MaxHostedServices);
      return sb.ToString();
    }

    public override int GetHashCode() {
      return base.GetHashCode();
    }

    public override bool Equals(object obj) {
      if (obj == null)
        return false;
      Subscription sub = obj as Subscription;
      if ((this.SubscriptionID == sub.SubscriptionID))
        return true;
      else
        return false;
    }

    public override IDeepCloneable Clone(Cloner cloner) {
      return new Subscription(this, cloner);
    }
  }
}
